----------------------------------------------------------------------------------------------------------------
---	DEM WGS84 Whole Earth importer Scripted FREE Plugin OBJECT   (work only with all 16 dem files presents)
---	NEED the BinaryData.dlx 1.04 Plugin script extension from J. Marcin Iwanski   http://members.xoom.com/Glus
--- Use to import and fence the earth dataset (933'120'000 points) 
--- Download the FULL dataset at http://www.ngdc.noaa.gov/seg/topo/gltiles.shtml  dont forget to add the .dem extension
--- (16 files) in same folder with ESRI Headers (.hdr)
--- Download all headers at ftp://ftp.ngdc.noaa.gov/GLOBE_DEM/data/elev/esri/hdr/ these files are with .hdr extensions
--- Put on max3-viz3/scripts/startup folder and restart max. Find it on Create Objects, ARCHIDATA-sa category
--- if you need increase script memory : uncomment the following heapsize+=100000000 command (remove the ---)
--- by Stephen Leger 				contact: steph@secondworld.com	
--- http://www.secondworld.com   	http://www.archidata-sa.com		
----------------------------------------------------------------------------------------------------------------
--- heapsize+=100000000 

plugin SimpleObject DEM_Earth 
category:"ARCHIDATA-sa"
name:"DEM_Earth"
classID:#(0x3e072e65, 0xb1e52e8) 
(	local basefn
	local FlipByte, flipbyteorder	
	fn flipbyteorder str=
		(	local a
			if FlipByte then
			(	a=for n in 9 to 16 collect bit.get str n
				a+=for n in 1 to 8 collect bit.get str n
				for n in 1 to a.count do str=bit.set str n a[n]
				str = signit str 16	
				return str
				)
			else 
			(	str = signit str 16
				return str
				)
		)---end fn

	fn readhdr f=
	(	str = readLine f
		ordstr= filterstring str " "
		return ordstr[2]
		)
	parameters  infoRlock rollout:roInfo
	(	elev	type:#float animatable:false	default:0
		derive	type:#float animatable:false	default:0
		size_x	type:#float animatable:false	default:1
		size_y	type:#float animatable:false	default:1
		)	

	parameters	paramRlock rollout:roMesh
	(	DEMIN type:#stringtab tabSize:16 tabSizeVariaRle:false
		Flag_first	type:#Boolean  animatable:false default:false
		step_y 	type:#integer animatable:false ui:spnstep_y default:1
		step_x 	type:#integer animatable:false ui:spnstep_x default:1
		Startv 	type:#integer animatable:false ui:spnStartv default:1
		Starth 	type:#integer animatable:false ui:spnStarth default:1
		countv 	type:#integer animatable:false ui:spncountv default:1
		counth 	type:#integer animatable:false ui:spncounth default:1
		elevC	type:#float animatable:false
		deriveC	type:#float animatable:false
		)
	parameters	paramalt rollout:roMaterial
	(	alt1 	type:#float animatable:false ui:spnAlt1 default:50
		alt2 	type:#float animatable:false ui:spnAlt2 default:200
		alt3 	type:#float animatable:false ui:spnAlt3 default:750
		alt4 	type:#float animatable:false ui:spnAlt4 default:1900
		alt5 	type:#float animatable:false ui:spnAlt5 default:3000
		)
	rollout roInfo "Info"
	(	Group "Files"
		(	label lab102 "Files : "
			label lab101 "Points:"
			)
		group "Coords"
		( 	label lab201 "Long : "
			label lab203 "Latt : "
			label lab205 "Center : "
			label lab207 "Reg cell x : "
			label lab208 "Reg cell y : "
			)	
		on roInfo open do
		(	if DEMIN[1] != undefined do
			(	lab101.text= ("Points : "+(counth/step_x*countv/step_y)as string+" / "+(counth*countv)as string)
				lab201.text= ("Long : "+derive as string+" / "+(derive+grid_size_x*counth)as string)
				lab102.text= ("Files : "+getFilenameFile DEMIN[1]+"  to  "+getFilenameFile DEMIN[16])
				lab203.text= ("Latt : "+elev as string+" / "+(elev-grid_size_y*countv)as string)
				lab205.text= ("Center : "+elevC as string+" / "+deriveC as string)
				lab207.text= ("Reg cell x : "+size_x as string)
				lab208.text= ("Reg cell y : "+size_y as string)
				)
			)
		)	
		
	rollout roMesh "Mesh"
	(	group "Mesh Density"
		(	spinner spnstep_x "Step X :" range:[1,10000,20] type:#integer enabled:false
			spinner spnstep_y "Step Y :" range:[1,10000,20] type:#integer enabled:false
			)
		group "Clipping"
		(	spinner spnStartv "Top :" range:[1,10000000,1] type:#integer enabled:false
			spinner spncountv "Bottom :" range:[1,10000000,1] type:#integer enabled:false
			spinner spnStarth "Left :" range:[1,10000000,1] type:#integer enabled:false
			spinner spncounth "Right :" range:[1,10000000,1] type:#integer enabled:false
			)
	
		on roMesh open do 
		(	if DEMIN[1] != undefined do
			(	spnstep_y.enabled=true
				spnstep_x.enabled=true
				spnStartv.enabled=true
				spnStarth.enabled=true
				spncountv.enabled=true
				spncounth.enabled=true
				)
			)
		)
	rollout roMaterial "Material" rolledUp:true
	(	group "Altitude material"
		(	spinner spnAlt1 "Alt 1 :" range:[1,10000,50] type:#float 
			spinner spnAlt2 "Alt 2 :" range:[1,10000,200] type:#float
			spinner spnAlt3 "Alt 3 :" range:[1,10000,750] type:#float 
			spinner spnAlt4 "Alt 4 :" range:[1,10000,1900] type:#float
			spinner spnAlt5 "Alt 5 :" range:[1,10000,3000] type:#float
			)
		)
	rollout roAbout "About" rolledUp:true
	(	group "Info"
		(	label lab11 "Full Earth DEM WGS84 manager."
			label lab18 "Beta 07.02"
			)
		group "Contact"
		(	label lab07 "steph@secondworld.com"
			label lab08 "http://www.secondworld.com"
			label lab09 "http://www.archidata-sa.com"
			)
		)
	
	on buildmesh do
	(	if DEMIN[1] == undefined do
		(	BaseFileName = (getOpenFileName Caption:"Choose DEM File" types:"Header (*.hdr)|*.hdr|Dem (*.dem)|*.dem|All files(*.*)|*.*|") as string
			FilesTab=(getfiles (getfilenamepath BaseFileName+"*.dem"))
			for n in 1 to FilesTab.count do DEMIN[n] = FilesTab[n]
			flag_first=on
			)
		
		start = timeStamp() 
		
		HDRIN = (getFilenamePath DEMIN[1]+getFilenameFile DEMIN[1]+".hdr")
		h = openFile 	HDRIN
			while h == undefined do 
			(	BaseFileName = (getOpenFileName caption:"DEM files not found ..." types:"Header (*.hdr)|*.hdr|Dem (*.dem)|*.dem|All files(*.*)|*.*|") as string
				FilesTab=(getfiles (getfilenamepath BaseFileName+"*.dem"))
				for n in 1 to FilesTab.count do DEMIN[n] = FilesTab[n]
				HDRIN = (getFilenamePath DEMIN[1]+getFilenameFile DEMIN[1]+".hdr")					
				h = openFile HDRIN
				)
		
		FlipByte= (readhdr h == "M")  ---check byte order M=Motorolla I=Intel
		skiptonextline h
		profils = 21600
		points =  43200
		for n in 1 to 7 do skiptonextline h
		miss_flag   = readhdr h as integer
		left_map_x  = readhdr h as float
		upper_map_y = readhdr h as float
		grid_size_x = readhdr h as float
		grid_size_y = readhdr h as float
		grid_size_x =  360/43200 as float   ---closed shape : 	 segments = vertex
		grid_size_y =  180/21600 as float   ---?? open half shape : segments = vertex-1  --> 21599
		
		close h


		if flag_first do    
		(	countv=profils
			counth=points
			step_x= 400 
			step_y= 400
			roMesh.spnstep_y.enabled=true
			roMesh.spnstep_x.enabled=true
			roMesh.spnStartv.enabled=true
			roMesh.spnStarth.enabled=true
			roMesh.spncountv.enabled=true
			roMesh.spncounth.enabled=true
			)
		flag_first=off	

--------------------------------
		
		while (2*step_x) > counth do step_x-=1 
		while (2*step_y) > countv do step_y-=1 
		while starth+counth > (points+1)  do counth -=1
		while startv+countv > (profils+1) do countv -=1

		EndClose  =	startv+countv+1 > profils and starth+counth+1 > points and (  (elevC > 4 or elevC < -4)  ) 
		FullModel = starth == 1 and  starth+counth+1 > points

	f=#()
	try	(
			Rb=6378.137 as float---km
			Rl=	6356.7523141 as float

			Perim=Rb*2*pi
			TerrePt=Perim/360

			vert=#()
			mid=#()
			
			r2d_x= cos elevC*Rb
			d2d_x= r2d_x*sin (grid_size_x/2)
			ang_proj= 2*asin (d2d_x/Rb)
			size_x =TerrePt*ang_proj 
			size_y =TerrePt*grid_size_y
			derive = left_map_x+grid_size_x*(starth-1)
			elev  = upper_map_y-grid_size_y*(startv-1)
			center=[0,0,0]	
---------------------------------------
---HELMERT's   step1 (WGS84 appendix e)
---------------------------------------
	a=Rb
	b=Rl
			flat=(a-b)/a	---f= flattening of ellipsoid
			e2=flat*(2-flat)---e= eccentricity of ellipsoid
  	

			hc= ((Rb-Rl)/(Rb+Rl)as float)^2
			Pv=pi*(Rb+Rl)*(1+hc/4 as float+hc^2/64 as float+hc^3/256 as float+hc^4/1024 as float)

			roInfo.lab101.text= ("Points : "+(counth/step_x*countv/step_y)as string+" / "+(counth*countv)as string)
			roInfo.lab201.text= ("Long : "+derive as string+" / "+(derive+grid_size_x*counth)as string)
			roInfo.lab102.text= ("Files : "+getFilenameFile DEMIN[1]+"  to  "+getFilenameFile DEMIN[16])	
			roInfo.lab203.text= ("Latt : "+elev as string+" / "+(elev-grid_size_y*countv)as string)
			roInfo.lab205.text= ("Center : "+elevC as string+" / "+deriveC as string)
			roInfo.lab207.text= ("Reg cell x: "+size_x as string)
			roInfo.lab208.text= ("Reg cell y: "+size_y as string)


			TotV=0
			clipvout=off
			facesv=0
----------------------------------------------------------------------

			for Vtiles in 1 to 4 do --- vertical 4 tiles of 4 files eatch
			(	for n in (Vtiles*4-3) to (Vtiles*4) do f[n]= (BinaryFile DEMIN[n])
				if clipvout do continue ---clip file vert out	
				Fcountv = if Vtiles==1 or Vtiles==4 then 4800 else 6000						
				clipvin = startv > TotV+1				     ---check for vert clip in
				clipvout=(startv-1+countv) 	< TotV+Fcountv   ---check for vert clip out

				Fstartv = if clipvin then (startv-TotV) else ( step_y - Mod (Fcountv - (Mod (startv-TotV) Fcountv)) step_y )
	
				if clipvin and Fstartv > Fcountv do	(TotV+=Fcountv ;continue) ---clip file vert in
				Fcountv = if clipvout then (Fcountv-(TotV+Fcountv-(startv-1+countv))) else Fcountv	---Totv=21600-21200
				TotV += (if clipvin then Fstartv+Fcountv else Fcountv)
				Fcountv = if clipvin  then (Fcountv-Fstartv- mod (Fcountv-Fstartv) step_y) else (Fcountv - mod Fcountv step_y)	
				
				facesv+=Fcountv 
 		---	print ("start at "+Fstartv as string+"  count "+Fcountv as string)

				for b in 1 to Fcountv by step_y do
				(	derive = Left_Map_x+grid_size_x*(starth-1)
					cliphout=off
					for Htiles in 1 to 4 do ---horizontal 4 files tiles 
					(	Fcounth = 10800	
						if b==1 do seek f[Htiles+(Vtiles-1)*4] (2*(Fstartv-1)*points/4)	1
						if cliphout do continue			
						cliphin = starth 	 	> Fcounth*(Htiles-1)+1 ---check for hor clip in
						cliphout= starth+counth < Fcounth*Htiles+1     ---check for hor clip out
						Fstarth = if cliphin then (starth-(Htiles-1)*Fcounth)
											 else step_x - Mod (Fcounth*Htiles-Mod (starth) Fcounth) step_x---file offset 
						if cliphin and starth >  (Fcounth*Htiles) do continue 
					
						Fcounth = if cliphout then (starth+counth-(Htiles-1)*Fcounth) else Fcounth
						Fcounth = if cliphin 	then (	(Fcounth-Fstarth)- mod (Fcounth-Fstarth) step_x	)
									 			else (	Fcounth - mod Fcounth step_x ) --- byte 2read 

			---	if b==1 do print ("seekv "+(2*(Fstartv-1)) as string +"seekh "+(2*(Fstarth-1)) as string)
					
						for g in 1 to Fcounth by step_x do 
						(	if g==1 do seek f[Htiles+(Vtiles-1)*4] (2*(Fstarth-1)) 1
							
							val=flipbyteorder (ReadBinWord f[Htiles+(Vtiles-1)*4])	
							mat=(	if val == miss_flag then 1
									else if val < alt1 then 2
									else if val < alt2 then 3
									else if val < alt3 then 4
									else if val < alt4 then 5
									else if val < alt5 then 6
									else 7
									)
						
							val = if val != miss_flag then (val/1000 as float) else 0
							append mid mat
							append mid mat

							v= a*sqrt(1-e2 *(sin elev)^2)
							c = [(v+val)*(cos elev)*(cos (derive-90)),(v+val)*(cos elev)*(sin (derive-90)),(v*(1-e2)+val)*sin elev]

							append vert c	
							derive += grid_size_x*step_x
							seek f[Htiles+(Vtiles-1)*4] ((step_x-1)*2) 1   --- step skip	
							) ---end for g
						seek f[Htiles+(Vtiles-1)*4] (2*(points/4-Fcounth-Fstarth+1)) 1	--- next line
						seek f[Htiles+(Vtiles-1)*4] (2*(step_y-1)*points/4)	1  --- skip nlignes
						) --- end file ID
					
					if (not FullModel) do for n in 1 to 2 do deleteitem mid mid.count
					elev -= grid_size_y*step_y

					)
				for n in 1 to 4 do close f[n+(Vtiles-1)*4]	
				)

---------------------------------------------------------
			pts = vert.count/(facesv/step_y)
			
			if EndClose then
			(	--- for n in 1 to (pts-1) do deleteitem mid (mid.count-n)
				)
			else 
			(	for n in 1 to ( if FullModel then (pts)*2 else (pts-1)*2) do deleteitem mid mid.count 
				)
				
			
	
			fc=#()
			for b in 1 to (facesv/step_y-1) do
			(	for g in 1 to (pts-1) do
				(	append fc [(b-1)*pts+g+1,(b-1)*pts+g,b*pts+g]
					append fc [b*pts+g+1,(b-1)*pts+g+1,b*pts+g]	
					)
				if FullModel do
				(	append fc [(b-1)*pts+1	,b*pts	,(b+1)*pts]
					append fc [b*pts+1		,(b-1)*pts+1	,(b+1)*pts]
					)	
				)
			elev=0
			if EndClose do
			(	derive = Left_Map_x+grid_size_x*(starth-1)
			
				for n in 1 to pts do
				(	append vert [0,0,-Rl]
					derive += grid_size_x*step_x
					)
				vnum=vert.count-2*pts

				for n in 1 to pts-1 do
				(	append fc [vnum+n+1,vnum+n,vnum+n+pts]
					append fc [vnum+n+pts+1,vnum+n+1,vnum+n]
					)
				append fc [vert.count-pts,vert.count-pts-1,vert.count-1]
				append fc [vert.count,vert.count-pts,vert.count-pts-1]
				)
							
	---		print ("vertex : "+vert.count as string)
	---		print ("Faces : "+fc.count as string)
	---		print ("Mat ID : "+mid.count as string)
			m= mesh
			setMesh m vertices:vert faces:fc materialIds:mid	 --- fill mesh with collected datas
			update m
			)
	catch messagebox ("Import failure !")
	end = timeStamp() 
	Tcount= ((end - start) / 1000.0)
	print ("Import time : "+Tcount as string+" seconds")
		)

	tool create
	(	on mousePoint click do
			case click of 
			(   1: ()
            	2: #stop
       			)        
		on mouseMove click do 
			case click of 
			(	2:()
        		)        
		)
	)--- end plugin
